/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2004-2018 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * https://oss.oracle.com/licenses/CDDL+GPL-1.1
 * or LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package messages;

import java.util.*;


public class BookstoreMessages_es_MX extends ListResourceBundle {
    static final Object[][] contents =
    {
        {
            "ServerError",
            "Su petici" + "\u00f3" +
            "n no pudo completarse. El servidor devolvi" + "\u00f3" +
            " el error siguiente: "
        },
        { "TitleServerError", "Error en el Servidor" },
        { "TitleShoppingCart", "Carro de Compras" },
        { "TitleReceipt", "Recibo" },
        { "TitleBookCatalog", "Cat" + "\u00e1" + "logo" },
        { "TitleCashier", "Cajero" },
        { "TitleBookDescription", "Descripci" + "\u00f3" + "n del Libro" },
        { "Visitor", "Es visitante n" + "\u00fa" + "mero " },
        { "What", "Qu" + "\u00e9" + " libros leemos" },
        {
            "Talk",
            " describe como componentes de software de web pueden transformar la manera en que desrrollamos aplicaciones para el web. Este libro es obligatorio para cualquier programador de respeto!"
        },
        { "Start", "Empezar a Comprar" },
        { "Critics", "Esto es lo que dicen los cr" + "\u00ed" + "ticos: " },
        { "Price", "Precio: " },
        { "CartRemoved", "Acaba de quitar " },
        { "CartCleared", "Acaba de vaciar el carro de compras." },
        { "CartContents", "Su carro de compras tiene " },
        { "CartItem", " art" + "\u00ed" + "culo" },
        { "CartItems", " art" + "\u00ed" + "culos" },
        { "CartAdded1", "A" + "\u00f1" + "adi" + "\u00f3" + " " },
        { "CartAdded2", " a su carro de compras." },
        { "CartCheck", "Comprobar el Carro de Compras" },
        { "CartAdd", "A" + "\u00f1" + "adir al Carro de Compras" },
        { "By", "por" },
        { "Buy", "Comprar Sus Libros" },
        { "Choose", "Escoja de nuestro cat" + "\u00e1" + "logo:" },
        { "ItemQuantity", "Cantidad" },
        { "ItemTitle", "T" + "\u00ed" + "tulo" },
        { "ItemPrice", "Precio" },
        { "RemoveItem", "Quitar art" + "\u00ed" + "culo" },
        { "Subtotal", "Subtotal:" },
        { "ContinueShopping", "Continuar Comprando" },
        { "Checkout", "Salir" },
        { "ClearCart", "Vaciar el Carro de Compras" },
        { "CartEmpty", "Su carro de compras esta vac" + "\u00ed" + "o." },
        { "Amount", "Su importe total es:" },
        {
            "Purchase",
            "Para poder comprar los art" + "\u00ed" +
            "culos en su carro de compras, facilite la informaci" + "\u00f3" +
            "n siguiente:"
        },
        { "Name", "Nombre:" },
        {
            "CCNumber",
            "N" + "\u00fa" + "mero de Tarjeta de Cr" + "\u00e9" + "dito:"
        },
        { "Submit", "Entregar la Informaci" + "\u00f3" + "n" },
        { "Catalog", "Volver al Cat" + "\u00e1" + "logo" },
        { "ThankYou", "Gracias por su compra " },
        { "ThankYouParam", "Gracias, {0} por comprar sus libros aqui" },
        
        { "OrderError", "No se pudo completar su pedido debido a escasez de inventario." },
        { "With", "Con" },
        { "Shipping", "Env" + "\u00ed" + "o:" },
        { "QuickShip", "Env" + "\u00ed" + "o Aprisa" },
        { "NormalShip", "Env" + "\u00ed" + "o Normal" },
        { "SaverShip", "Env" + "\u00ed" + "o Descuento" },
        { "ShipDate", "Su compra ser" + "\u00e1" + " enviada " },
        { "ShipDateLC", "su order ser" + "\u00e1" + " enviada " },
        {
            "ConfirmAdd",
            "Acaba de a" + "\u00f1" + "adir \"{0}\" a su cesta de compras"
        },
        { "ConfirmRemove", "Acaba de sacar \"{0}\" de su cesta de compras" },
        
        {
            "CartItemCount",
            
            "Su cesta de compras contiene " + "{0,choice,0#ning" + "\u00fa" +
            "n articulo|1#un articulo|1< {0} articulos}"
        },
        
        {
            "Newsletters",
            "Suscripci" + "\u00f3" + "n gratuita a nuestro bolet" + "\u00ed" +
            "n:"
        },
        
        { "ThanksMsg", "Gracias. Por favor cliquee aqui para comprar sus libros." },
        
        {
            "DukeFanClub",
            "Desear" + "\u00ed" +
            "a hacerme miembro del Duke Fan Club gratuitamente con mi compra de mas de 100" +
            "\u20a0"
        },
        
        { "UpdateQuantities", "Actualice las cantidades" },
        
        {
            "QuantitiesUpdated",
            "Acaba de actualizar las cantidades en su cesta de compras"
        },
        
        { "Quantities", "Copias del libro en su cesta de compras" },
        
        { "ChooseLocale", "Elija su Idioma en el Mapa" },
        
        { "English", "ingl" + "\u00e9" + "s" },
        
        { "German", "al" + "\u00e9" + "man" },
        
        { "Spanish", "espa" + "\u00f1" + "ol" },
        
        { "French", "franc" + "\u00e9" + "es" },
        { "CustomerInfo", "Incorpore su informaci" + "\u00f3" +
            "n en la forma." },
        {
            "BookCatalog",
            "Agregue los libros del cat" + "\u00c2" +
            "logo a su carro de compras."
        },
        {
            "ShoppingCart",
            "Esta p" + "\u00c2" +
            "gina enumera los libros en su carro de compras."
        }
    };

    public Object[][] getContents() {
        return contents;
    }
}
