DROP TABLE D;
DROP TABLE C;
DROP TABLE B;
DROP TABLE A;


CREATE TABLE A
(
    ID INT          PRIMARY KEY,
    NAME   VARCHAR(32) NULL
) ENGINE=INNODB;

CREATE TABLE B
(
    ID     INT          PRIMARY KEY,
    NAME   VARCHAR(32) NULL,
    AID    INT          NULL,
    FOREIGN KEY (AID)   REFERENCES A (ID)
) ENGINE=INNODB;

CREATE TABLE C
(
    ID   INT          PRIMARY KEY,
    NAME VARCHAR(32) NULL,
    AID   INT          NULL,
    BID   INT          NULL,
    FOREIGN KEY (AID)  REFERENCES A (ID),
    FOREIGN KEY (BID)  REFERENCES B (ID),
    UNIQUE (BID)
) ENGINE=INNODB;

CREATE TABLE D
(
    ID   INT          PRIMARY KEY,
    NAME VARCHAR(32) NULL,
    AID   INT          NULL,
    BID   INT          NULL,
    CID   INT          NULL,
    FOREIGN KEY (AID)  REFERENCES A (ID),
    FOREIGN KEY (BID)  REFERENCES B (ID),
    FOREIGN KEY (CID)  REFERENCES C (ID)
) ENGINE=INNODB;

commit;

quit;
