/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2018 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * https://oss.oracle.com/licenses/CDDL+GPL-1.1
 * or LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package Data;

import javax.ejb.*;
import java.util.*; 

/**
 * Created Dec 16, 2002 1:22:14 PM
 * Code generated by the Forte For Java EJB Builder
 * @author mvatkina
 */


public abstract class PartsBean implements javax.ejb.EntityBean {
    
    private javax.ejb.EntityContext context;
    
    
    /**
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     */
    public void setEntityContext(javax.ejb.EntityContext aContext) {
        context=aContext;
    }
    
    
    /**
     * @see javax.ejb.EntityBean#ejbActivate()
     */
    public void ejbActivate() {
        
    }
    
    
    /**
     * @see javax.ejb.EntityBean#ejbPassivate()
     */
    public void ejbPassivate() {
        
    }
    
    
    /**
     * @see javax.ejb.EntityBean#ejbRemove()
     */
    public void ejbRemove() {
        
    }
    
    
    /**
     * @see javax.ejb.EntityBean#unsetEntityContext()
     */
    public void unsetEntityContext() {
        context=null;
    }
    
    
    /**
     * @see javax.ejb.EntityBean#ejbLoad()
     */
    public void ejbLoad() {
        
    }
    
    
    /**
     * @see javax.ejb.EntityBean#ejbStore()
     */
    public void ejbStore() {
        
    }
    
    public abstract java.lang.Integer getPartid();
    public abstract void setPartid(java.lang.Integer partid);
    
    public abstract java.lang.String getName();
    public abstract void setName(java.lang.String name);
    
    public abstract java.lang.String getColor();
    public abstract void setColor(java.lang.String color);
    
    public abstract java.math.BigDecimal getWeight();
    public abstract void setWeight(java.math.BigDecimal weight);
    
    public abstract java.lang.Double getPrice();
    public abstract void setPrice(java.lang.Double price);
    
    public abstract java.util.Collection getSuppliers();
    
    public abstract void setSuppliers(java.util.Collection suppliers);
    
    public java.lang.Integer ejbCreate(java.lang.Integer partid, java.lang.String name, java.lang.String color, java.math.BigDecimal weight, java.lang.Double price) throws javax.ejb.CreateException {
        if (partid == null) {
            throw new javax.ejb.CreateException("The partid is required.");
        }
        setPartid(partid);
        setName(name);
        setColor(color);
        setWeight(weight);
        setPrice(price);

        return null;
    }
    
    public void ejbPostCreate(java.lang.Integer partid, java.lang.String name, java.lang.String color, java.math.BigDecimal weight, java.lang.Double price) throws javax.ejb.CreateException {
        
    }
    
    public void addSupplier(Data.LocalSuppliers supplier) {
        System.out.println("Debug : PartsBean addSupplier");
        if (supplier != null)
            System.out.println("Debug : supplier is null");
        try {
            java.util.Collection sups = getSuppliers();
            sups.add(supplier);

        } catch (Exception ex) {
            throw new EJBException(ex.getMessage());
        }
    }
    
    public void dropSupplier(Data.LocalSuppliers supplier) {
        System.out.println("Debug : PartsBean dropSupplier");
        try {
            java.util.Collection suppliers = getSuppliers();
            suppliers.remove(supplier);
        } catch (Exception ex) {
            throw new EJBException(ex.getMessage());
        }
    }
    
    public void testInCascadeDelete() {
        throw new RuntimeException("Called testInCascadeDelete!!!");
    }
    
}
